package com.infovis.callgraph;

/**
 * Callbacks to the CallGraphView.
 * 
 * @author DarkMatt
 *
 */
public interface CallBackInterface {

	/**
	 * Callback to set the number of active edges.
	 * 
	 * @param count
	 */
	public void setActiveEdgeCount(int count);
	
	/**
	 * Callback to set a text (for debugging).
	 * 
	 * @param text
	 */
	public void setActiveText(String text);
	
	/**
	 * Callback to set the current progress bar from outside.
	 * 
	 * @param current
	 * @param maximum
	 */
	public void setStatus(int current, int maximum);
	
}
