package com.infovis.callgraph;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;

/**
 * 
 * Auto generated.
 * 
 * http://stackoverflow.com/questions/3971534/how-to-force-java-to-reload-class-upon-instantiation
 *
 */

public class Reloader extends ClassLoader {
	
	public Reloader(){
        super(Reloader.class.getClassLoader());
    }
	
    /*
	public static void main(String[] args) throws Exception {
        do {
            Object foo = new Reloader().loadClass("MyFoo").newInstance();
            System.out.println("LOADED: " + foo); // Overload MyFoo#toString() for effect
            System.out.println("Press <ENTER> when MyFoo.class has changed");
            System.in.read();
        } while (true);
    }
    */

    @Override
    public Class<?> loadClass(String s) {
        return findClass(s);
    }

    @Override
    public Class<?> findClass(String s) {
        try {
            byte[] bytes = loadClassData(s);
            return defineClass("com.infovis.callgraph.renderer.RenderThread", bytes, 0, bytes.length); //used to be s
        } catch (IOException ioe) {
            try {
                return super.loadClass(s); //TODO not implemented..
            } catch (ClassNotFoundException ignore) { }
            ioe.printStackTrace(System.out);
            return null;
        }
    }

    private File resolveAbsolutePath(String path) {
		
		/*URI uri = null;
		try {
			uri = new URI("file://"+TextRenderer.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
        return new File(f.getParent() + "/" + path);*/
		
		Bundle bundle = Platform.getBundle("com.infovis.callgraph");
		Path realPath = new Path("bin/com/infovis/callgraph/renderer/RenderThread.class");
		
		URL fileURL = FileLocator.find(bundle, realPath, null);
		URL resolved = null;
		
		System.out.println("in reloader " + fileURL.toString());
		
		try {
		    resolved = FileLocator.resolve(fileURL);
		} catch (IOException e) {
		    throw new RuntimeException(e);
		}
		
		return new File(resolved.getPath());
        
	}
    
    private byte[] loadClassData(String className) throws IOException {
        File f = resolveAbsolutePath(className);//new File("bin/" + className.replaceAll("\\.", "/") + ".class"); //
        int size = (int) f.length();
        byte buff[] = new byte[size];
        FileInputStream fis = new FileInputStream(f);
        DataInputStream dis = new DataInputStream(fis);
        dis.readFully(buff);
        dis.close();
        return buff;
    }
}
