package tools;

import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;

public class FileIO {

	/**
	 * Gets a path to a resource. Don't use inside a jar.
	 * 
	 * @param path
	 * @return
	 */
	public static File resolveAbsolutePath(String path) {
		
		/*URI uri = null;
		try {
			uri = new URI("file://"+TextRenderer.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
        return new File(f.getParent() + "/" + path);*/
		
		Bundle bundle = Platform.getBundle("callgraph");
		Path realPath = new Path(path);
		URL fileURL = FileLocator.find(bundle, realPath, null);
		
		if (fileURL != null) {
			URL resolved = null;
			try {
			    resolved = FileLocator.resolve(fileURL);
			} catch (IOException e) {
			    throw new RuntimeException(e);
			}
			
			return new File(resolved.getPath());
		} else {
			return new File("");
		}
        
	}
	
	/**
	 * Gets a path to a resource.
	 * 
	 * @param path
	 * @return
	 * @throws IOException
	 */
	public static InputStreamReader resolveAbsolutePathFR(String path) throws IOException {
		
		/*URI uri = null;
		try {
			uri = new URI("file://"+TextRenderer.class.getProtectionDomain().getCodeSource().getLocation().getPath());
		} catch (URISyntaxException e1) {
			throw new RuntimeException("URI fault");
		}
        File f = new File(uri);
        return new File(f.getParent() + "/" + path);*/
		
		Bundle bundle = Platform.getBundle("callgraph");
		Path realPath = new Path(path);
		URL fileURL = FileLocator.find(bundle, realPath, null);
		
		if (fileURL != null) {
			URL resolved = null;
			resolved = FileLocator.resolve(fileURL);
			
			System.out.println(fileURL.getPath());
			
			return new InputStreamReader(resolved.openStream());
		} else {
			return null;
		}
        
	}
	
}
